From 12c0cf674830757960c40d945e87aa087cea5468 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 711/1001] Adapt the cache scripts to the new CachedFunction


---

diff --git a/check-cache-coverage.py b/check-cache-coverage.py
index a753f56..d092dfd 100755
--- a/check-cache-coverage.py
+++ b/check-cache-coverage.py
@@ -13,12 +13,14 @@ forcibly re-warms the cache.
 Authors:    Ralph Bean <rbean@redhat.com>
 """
 
-from __future__ import unicode_literals
+from __future__ import unicode_literals, print_function
 
 import sys
 import dogpile.cache
 
-import hubs.widgets.base
+import hubs.app
+import hubs.widgets
+import hubs.widgets.caching
 import hubs.models
 
 import fedmsg.config
@@ -27,18 +29,21 @@ config = fedmsg.config.load_config()
 
 empty, full = 0, 0
 session = hubs.models.init(config['hubs.sqlalchemy.uri'])
-for widget in session.query(hubs.models.Widget).all():
-    key = hubs.widgets.base.cache_key_generator(widget, **widget.config)
-    result = hubs.widgets.base.cache.get(key, ignore_expiration=True)
-    if isinstance(result, dogpile.cache.api.NoValue):
-        empty += 1
-    else:
-        full += 1
-    sys.stdout.write('.')
-    sys.stdout.flush()
+
+# Register widgets
+hubs.widgets.registry.register_list(hubs.app.app.config["WIDGETS"])
+
+for w_instance in session.query(hubs.models.Widget).all():
+    for fn_name, fn_class in w_instance.module.get_cached_functions().items():
+        if fn_class(w_instance).is_cached():
+            full += 1
+        else:
+            empty += 1
+        sys.stdout.write('.')
+        sys.stdout.flush()
 sys.stdout.write('\n')
 sys.stdout.flush()
 
 total = empty + full
-print full, "cache values found. ", empty, "are missing."
-print full / float(total) * 100, "percent cache coverage."
+print(full, "cache values found. ", empty, "are missing.")
+print(full / float(total) * 100, "percent cache coverage.")
diff --git a/smart_cache_invalidator.py b/smart_cache_invalidator.py
index 25c2540..ebf0de6 100755
--- a/smart_cache_invalidator.py
+++ b/smart_cache_invalidator.py
@@ -18,8 +18,10 @@ import fedmsg.config
 import fedmsg.meta
 
 
+import hubs.app
 import hubs.models
 import hubs.widgets.base
+import hubs.widgets.caching
 
 # get the DB session
 fedmsg_config = fedmsg.config.load_config()
@@ -27,21 +29,24 @@ fedmsg.meta.make_processors(**fedmsg_config)
 
 session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'])
 
+# Register widgets
+hubs.widgets.registry.register_list(hubs.app.app.config["WIDGETS"])
+
 
 def do_list(args):
     ''' List the different widget for which there is data cached. '''
-    for widget in session.query(hubs.models.Widget).all():
-        key = hubs.widgets.base.cache_key_generator(widget, **widget.config)
-        result = hubs.widgets.base.cache.get(key, ignore_expiration=True)
-        if not isinstance(result, dogpile.cache.api.NoValue):
-            print('- Widget cached {0} (#{1}) in {2}'.format(
-                      widget.hub_id, widget.idx, widget.plugin))
+    for w_instance in session.query(hubs.models.Widget).all():
+        widget = w_instance.module
+        for fn_name, fn_class in widget.get_cached_functions().items():
+            if fn_class(w_instance).is_cached():
+                print('- Widget cached {0} (#{1}) in {2}'.format(
+                          w_instance.hub_id, w_instance.idx, w_instance.plugin))
 
 
 def do_clean(args):
     ''' Clean the widget for which there is data cached. '''
     for widget in args.widgets:
-        wid_obj = hubs.models.Widget.get(session, widget)
+        wid_obj = hubs.models.Widget.get(widget)
 
         if not wid_obj:
             wid_obj = session.query(hubs.models.Widget).filter_by(
@@ -52,7 +57,8 @@ def do_clean(args):
 
         print('- Removing cached {0} (#{1}) in {2}'.format(
               wid_obj.hub_id, wid_obj.idx, wid_obj.plugin))
-        result = hubs.widgets.base.invalidate_cache(wid_obj, **wid_obj.config)
+        for fn_class in wid_obj.module.get_cached_functions().values():
+            fn_class(wid_obj).invalidate()
 
 
 def setup_parser():

